<template lang="pug">
  div.column.q-pt-xl.q-pl-lg
    span Nome da família
    q-input(color="black" bg-color="white" outlined v-model="nome").q-py-xs
    div.q-pt-lg
      div.column
        span Responsáveis:
        span(v-for="resp in responsaveis").q-pl-md {{ resp.name || ''}}
      div.row.items-center
        q-input(
          color="black"
          bg-color="white"
          outlined
          v-model="responsavel"
          label="Username"
        ).q-py-xs
        q-icon(name="add_box" size="lg" @click="checkResp()").q-pl-md
    div.q-pt-lg
      div.column
        span Dependentes:
        span(v-for="resp in dependentes").q-pl-md {{ resp.name || ''}}
      div.row.items-center
        q-input(
          color="black"
          bg-color="white"
          outlined
          v-model="dependente"
          label="Username"
        ).q-py-xs
        q-icon(name="add_box" size="lg" @click="checkDep()").q-pl-md
    q-btn(v-if="!loading" color="secondary" text-color="white" glossy label="Avançar" @click="criarFamilia()").q-my-xl
    q-spinner-tail(v-else color="secondary" size="6em").self-center

</template>

<script>
import { mapGetters } from 'vuex'
import { QInput, QDate, QField, QSpinnerTail} from 'quasar'
import firebase from 'firebase'

export default {
  name: 'DetalhesFamilia',
  components: {
    QField,
    QInput,
    QDate,
    QSpinnerTail
  },
  data () {
    return {
      responsaveis: [],
      responsavel: '',
      dependentes: [],
      dependente: '',
      loading: false,
      nome: ''
    }
  },
  computed: {
    ...mapGetters( 'user', [
      'user'
    ]),
  },
  methods: {
    async checkUser (username) {
      var aux = {}
      const db = firebase.firestore()
      await db.collection("User")
        .where("username", "==", username)
        .get()
        .then(snap => {
          if (snap.empty) {
            this.$q.notify({
              type: 'negative',
              message: `Username não existe`
            })
          } else {
            var data = snap.docs[0].data()
            var id = snap.docs[0].id
            aux = { id, name: data.name }
          }
        })
      return aux
    },
    async checkResp () {
      var data = await this.checkUser(this.responsavel)
      if (data !== {}) {
        this.responsavel = ''
        this.responsaveis.push(data)
      }
    },
    async checkDep () {
      var data = await this.checkUser(this.dependente)
      if (data !== {}) {
        this.dependente = ''
        this.dependentes.push(data)
      }
    },
    async criarFamilia () {
      this.$emit('avancar', this.nome, this.dependentes, this.responsaveis)
    }
  },
  mounted () {
    this.responsaveis.push({id: this.user.data.id, name: this.user.data.displayName})
  }
}
</script>

<style lang="stylus">
.q-field__inner
  padding 0
</style>